image: node:latest

cache:
  paths:
    - node_modules/

stages:
  - setup
  - test
  - build
  - production

guideline_check:
  stage: setup
  only:
    refs:
      - merge_requests
    variables:
      - $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME =~ /dev\/.+\/.+/ && $CI_MERGE_REQUEST_TARGET_BRANCH_NAME != "master"
  except:
    - branches
  script:
    - echo "Correct dev guideline"

test_async:
  stage: test
  only:
    refs:
      - merge_requests
    variables:
      - $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME =~ /dev\/.+\/.+/ && $CI_MERGE_REQUEST_TARGET_BRANCH_NAME != "master"
  except:
    variables:
      - $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME =~ /doc\/.+\/.+/
  script:
    - echo "Installing node modules"
    - yarn
    - echo "Testing"
    - yarn test
    - echo "Passes all"

build:
  stage: build
  only:
    refs:
      - merge_requests
    variables:
      - $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME =~ /dev\/.+\/.+/ && $CI_MERGE_REQUEST_TARGET_BRANCH_NAME != "master"
  except:
    variables:
      - $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME =~ /doc\/.+\/.+/
  script:
    - echo "Installing node modules"
    - yarn
    - echo "Building client"
    - yarn build
    - echo "Built successful"

deploy_heroku:
  stage: production
  only:
    - staging
  except:
    variables:
      - $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME =~ /doc\/.+\/.+/
  script:
    - echo "Deploying"
    - apt-get update -qy
    - apt-get install -y ruby-dev
    - gem install dpl
    - dpl --provider=heroku --app=projectube-web --api-key=$HEROKU_API_KEY
    - echo "Deployed successful"
